<!DOCTYPE html>
<html>
  <head>
    <title>Task 37.30</title>
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css"
    />
    <!-- Data Table-->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
    />
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  </head>

  <body>
    <!-- Vùng header -->
    <div class="container">
      <div class="text-center">
        <h2>Danh sách người dùng đăng kí</h2>
      </div>
      <div class="form-group">
        <button class="btn btn-success" id="btn-add-user">
          <i class="fa fa-plus"></i>&nbsp; Thêm user
        </button>
      </div>
    </div>
    <!-- Vouche Data Table -->
    <div class="container">
      <table
        class="table table-bordered table-striped table-hover"
        id="user-table"
      >
        <thead>
          <tr>
            <th>Id</th>
            <th>Firstname</th>
            <th>Lastname</th>
            <th>Country</th>
            <th>Subject</th>
            <th>Customer Type</th>
            <th>Register Status</th>
            <th>Action</th>
          </tr>
        </thead>
      </table>
    </div>
    <!-- Vùng Modal -->

    <!-- Create user modal -->
    <div>
      <div id="create-user-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">Creat new user</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <form>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-create-firstname">First name</label>
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-create-firstname"
                      name="firstname"
                      placeholder="first name"
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-create-lastname">Last name</label>
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-create-lastname"
                      name="lastname"
                      placeholder="last name"
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-create-subject">Subject</label>
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-create-subject"
                      name="subject"
                      placeholder="subject"
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="select-create-country">Country</label>
                  </div>
                  <div class="col-sm-8">
                    <select
                      name="select-create-country"
                      id="select-create-country"
                      class="form-control"
                    >
                      <option value="VN">Việt Nam</option>
                      <option value="USA">USA</option>
                      <option value="AUS">Australia</option>
                      <option value="CAN">Canada</option>
                    </select>
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="select-create-customer-type"
                      >Customer Type</label
                    >
                  </div>
                  <div class="col-sm-8">
                    <select
                      name="select-create-customer-type"
                      id="select-create-customer-type"
                      class="form-control"
                    >
                      <option value="Standard">Standard</option>
                      <option value="Gold">Gold</option>
                      <option value="Premium">Premium</option>
                    </select>
                  </div>
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <button
                class="btn btn-secondary"
                id="btn-insert-cancel"
                data-dismiss="modal"
              >
                Cancel
              </button>
              <button class="btn btn-primary" id="btn-insert-user">
                Insert user
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Update user modal -->
    <div>
      <div id="update-user-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">Update user</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <form>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-update-firstname">First name</label>
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-update-firstname"
                      name="firstname"
                      placeholder="first name"
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-update-lastname">Last name</label>
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-update-lastname"
                      name="lastname"
                      placeholder="last name"
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="input-update-subject">Subject</label>
                  </div>
                  <div class="col-sm-8">
                    <input
                      type="text"
                      id="input-update-subject"
                      name="subject"
                      placeholder="subject"
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="select-update-country">Country</label>
                  </div>
                  <div class="col-sm-8">
                    <select
                      name="select-update-country"
                      id="select-update-country"
                      class="form-control"
                    >
                      <option value="VN">Việt Nam</option>
                      <option value="USA">USA</option>
                      <option value="AUS">Australia</option>
                      <option value="CAN">Canada</option>
                    </select>
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="select-update-customer-type"
                      >Customer Type</label
                    >
                  </div>
                  <div class="col-sm-8">
                    <select
                      name="select-update-customer-type"
                      id="select-update-customer-type"
                      class="form-control"
                    >
                      <option value="Standard">Standard</option>
                      <option value="Gold">Gold</option>
                      <option value="Premium">Premium</option>
                    </select>
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-4">
                    <label for="select-update-register-status"
                      >Register Status</label
                    >
                  </div>
                  <div class="col-sm-8">
                    <select
                      name="select-update-register-status"
                      id="select-update-register-status"
                      class="form-control"
                    >
                      <option value="New">New</option>
                      <option value="Accepted">Accepted</option>
                      <option value="Denied">Denied</option>
                    </select>
                  </div>
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <button class="btn btn-primary" id="btn-update-user">
                Update user
              </button>
              <button
                class="btn btn-secondary"
                id="btn-update-cancel"
                data-dismiss="modal"
              >
                Cancel
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Delete user modal -->
    <div>
      <div id="delete-user-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">Confirm xóa user</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <form>
                <div class="row form-group">
                  <div class="col-sm-12">
                    <p>Bạn có chắc chắn muốn xóa user?</p>
                  </div>
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <button class="btn btn-danger" id="btn-delete-user">
                Confirm user
              </button>
              <button
                class="btn btn-secondary"
                id="btn-delete-cancel"
                data-dismiss="modal"
              >
                Cancel
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </body>

  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    const gCONTENT_TYPE = "application/json;charset=UTF-8";

    //biến toàn cục để lưu trữ id user đang được update
    var gUserId = 0;

    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gUSER_COLS = [
      "id",
      "firstname",
      "lastname",
      "country",
      "subject",
      "customerType",
      "registerStatus",
      "action",
    ];

    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gUSER_ID_COL = 0;
    const gUSER_FIRST_NAME_COL = 1;
    const gUSER_LAST_NAME_COL = 2;
    const gUSER_COUNTRY_COL = 3;
    const gUSER_SUBJECT_COL = 4;
    const gUSER_CUSTOMER_TYPE_COL = 5;
    const gUSER_REGISTER_STATUS_COL = 6;
    const gUSER_ACTION_COL = 7;

    // Khai báo DataTable & mapping collumns
    var gUserTable = $("#user-table").DataTable({
      columns: [
        { data: gUSER_COLS[gUSER_ID_COL] },
        { data: gUSER_COLS[gUSER_FIRST_NAME_COL] },
        { data: gUSER_COLS[gUSER_LAST_NAME_COL] },
        { data: gUSER_COLS[gUSER_COUNTRY_COL] },
        { data: gUSER_COLS[gUSER_SUBJECT_COL] },
        { data: gUSER_COLS[gUSER_CUSTOMER_TYPE_COL] },
        { data: gUSER_COLS[gUSER_REGISTER_STATUS_COL] },
        { data: gUSER_COLS[gUSER_ACTION_COL] },
      ],
      columnDefs: [
        {
          // định nghĩa lại cột STT
          targets: gUSER_ID_COL,
          className: "text-center text-info",
        },
        {
          // định nghĩa lại cột action
          targets: gUSER_ACTION_COL,
          defaultContent: `
        <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
        <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
      `,
        },
      ],
    });

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
      // thực hiện tải trang
      onPageLoading();

      //gán sự kiện Update - Sửa 1 User
      $("#btn-add-user").on("click", function () {
        onBtnAddNewUserClick(this);
      });

      //gán sự kiện Update - Sửa 1 User
      $("#user-table").on("click", ".edit-user", function () {
        onBtnEditUserClick(this);
      });
      //gán sự kiện Delete - Xoá 1 User
      $("#user-table").on("click", ".delete-user", function () {
        onBtnDeleteUserClick(this);
      });
      //gán sự kiện insert user
      $("#btn-insert-user").on("click", function () {
        onBtnInsertUserToTable();
      });
      //gán sự kiện update user
      $("#btn-update-user").on("click", function () {
        onBtnUpdateUserToTable();
      });
      //gán sự kiện delete user
      $("#btn-delete-user").on("click", function () {
        onBtnDeleteUserToTable();
      });
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm thực thi khi trang được load
    function onPageLoading() {
      // 1 - R: Read / Load User to DataTable
      getAllUsers();
    }

    // Hàm xử lý sự kiện khi icon edit user trên bảng đc click
    function onBtnEditUserClick(paramBtnEdit) {
      gUserId = getUserIdFromButton(paramBtnEdit);
      console.log("Nút sửa được nhấn");
      console.log("Id của user là: " + gUserId);
      //load data into form
      getUserById(gUserId);
      // hiển thị modal lên
      $("#update-user-modal").modal("show");
    }
    // Hàm xử lý sự kiện khi icon edit User trên bảng đc click
    function onBtnDeleteUserClick(paramBtnDelete) {
      gUserId = getUserIdFromButton(paramBtnDelete);
      console.log("Nút xóa được nhấn");
      console.log("Id của user là: " + gUserId);
      //load data into form
      getUserById(gUserId);
      // hiển thị modal lên
      $("#delete-user-modal").modal("show");
    }

    function onBtnAddNewUserClick(paramBtnDelete) {
      // hiển thị modal trắng lên
      $("#create-user-modal").modal("show");
    }

    function onBtnInsertUserToTable() {
      //khai báo đối tượng
      var vUserObj = {
        firstname: "",
        lastname: "",
        subject: "",
        country: "",
        customerType: "",
      };

      //thu thập dữ liệu từ form
      readDataFromModal(vUserObj);

      //kiểm tra dữ liệu
      var vIsCheck = validateData(vUserObj);
      if (vIsCheck) {
        $.ajax({
          url: gBASE_URL,
          type: "POST",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(vUserObj),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleInsertUserSuccessFormCreate();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      }
    }

    function onBtnUpdateUserToTable() {
      //khai báo đối tượng
      var vUserObj = {
        firstname: "",
        lastname: "",
        subject: "",
        country: "",
        customerType: "",
        registerStatus: "",
      };

      //thu thập dữ liệu từ form
      readDataFromUpdateModal(vUserObj);

      //kiểm tra dữ liệu
      var vIsCheck = validateData(vUserObj);
      if (vIsCheck) {
        $.ajax({
          url: gBASE_URL + gUserId,
          type: "PUT",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(vUserObj),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleInsertUserSuccessFormUpdate();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      }
    }

    function onBtnDeleteUserToTable() {
      $.ajax({
        url: gBASE_URL + gUserId,
        type: "DELETE",
        contentType: gCONTENT_TYPE,
        success: function (paramVouchers) {
          handleDeleteUserSuccess();
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        },
      });
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm gọi api để lấy all danh sách user đăng ký
    function getAllUsers() {
      $.ajax({
        url: gBASE_URL,
        type: "GET",
        success: function (paramUsers) {
          loadDataToUserTable(paramUsers);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        },
      });
    }
    /** load User array to DataTable
     * in: User array
     * out: User table has data
     */
    function loadDataToUserTable(paramUserArr) {
      gUserTable.clear();
      gUserTable.rows.add(paramUserArr);
      gUserTable.draw();
    }

    //hàm dựa vào button detail (edit or delete) xác định được id user
    function getUserIdFromButton(paramButton) {
      var vTableRow = $(paramButton).parents("tr");
      var vUserRowData = gUserTable.row(vTableRow).data();
      return vUserRowData.id;
    }

    // hàm get user by id
    function getUserById(paramUserId) {
      $.ajax({
        url: gBASE_URL + paramUserId,
        type: "GET",
        success: function (paramUser) {
          showUserDataToModalUpdate(paramUser);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        },
      });
    }

    //thu thập dữ liệu nhập vào insert user
    function readDataFromModal(paramUserObj) {
      paramUserObj.firstname = $("#input-create-firstname").val();
      paramUserObj.lastname = $("#input-create-lastname").val();
      paramUserObj.subject = $("#input-create-subject").val();
      paramUserObj.country = $("#select-create-country").val();
      paramUserObj.customerType = $("#select-create-customer-type").val();
    }

    //hàm kiểm tra dữ liệu insert user
    function validateData(paramUserObj) {
      if (paramUserObj.firstname === "") {
        alert("First name chưa được nhập.");
        return false;
      }
      if (paramUserObj.lastname === "") {
        alert("Last name chưa được nhập.");
        return false;
      }
      if (paramUserObj.subject === "") {
        alert("Subject chưa được nhập.");
        return false;
      }
      return true;
    }

    //xử lý sự kiện khi nhấn nút button tạo user
    function handleInsertUserSuccessFormCreate() {
      alert("Thêm user thành công!");
      getAllUsers();
      resetCreateUserForm();
      $("#create-user-modal").modal("hide");
    }

    //hàm xóa trắng form create user
    function resetCreateUserForm() {
      $("#input-create-firstname").val("");
      $("#input-create-lastname").val("");
      $("#input-create-subject").val("");
      $("#select-create-country").val("VN");
      $("#select-create-customer-type").val("Standard");
    }

    //hàm thu thập dữ liệu form update modal
    function readDataFromUpdateModal(paramUserObj) {
      paramUserObj.firstname = $("#input-update-firstname").val();
      paramUserObj.lastname = $("#input-update-lastname").val();
      paramUserObj.subject = $("#input-update-subject").val();
      paramUserObj.country = $("#select-update-country").val();
      paramUserObj.customerType = $("#select-update-customer-type").val();
      paramUserObj.registerStatus = $("#select-update-register-status").val();
    }

    //xử lý sự kiện khi nhấn nút button update user
    function handleInsertUserSuccessFormUpdate() {
      alert("Cập nhật user thành công!");
      getAllUsers();
      resetCreateUserForm();
      $("#update-user-modal").modal("hide");
    }

    //hàm hiển thị user ra form
    function showUserDataToModalUpdate(paramUser) {
      $("#input-update-firstname").val(paramUser.firstname);
      $("#input-update-lastname").val(paramUser.lastname);
      $("#input-update-subject").val(paramUser.subject);
      $("#select-update-country").val(paramUser.country);
      $("#select-update-customer-type").val(paramUser.customerType);
      $("#select-update-register-status").val(paramUser.registerStatus);
    }

    //xử lý sự kiện khi nhấn nút button delete user
    function handleDeleteUserSuccess() {
      alert("Xác nhận đã xóa user thành công!");
      getAllUsers();
      resetCreateUserForm();
      $("#delete-user-modal").modal("hide");
    }
  </script>
</html>
